=== modified file 'bzrlib/commands.py'
--- bzrlib/commands.py	2010-08-13 07:56:06 +0000
+++ bzrlib/commands.py	2010-10-08 06:22:30 +0000
@@ -687,7 +687,12 @@
 
         self._setup_outf()
 
-        return self.run(**all_cmd_args)
+        try:
+            return self.run(**all_cmd_args)
+        finally:
+            # reset it, so that other commands run in the same process won't
+            # inherit state
+            trace.set_verbosity_level(0)
 
     def _setup_run(self):
         """Wrap the defined run method on self with a cleanup.

=== modified file 'bzrlib/tests/test_script.py'
--- bzrlib/tests/test_script.py	2010-09-13 09:00:03 +0000
+++ bzrlib/tests/test_script.py	2010-10-08 06:22:30 +0000
@@ -19,6 +19,7 @@
     commands,
     osutils,
     tests,
+    trace,
     ui,
     )
 from bzrlib.tests import script
@@ -245,6 +246,15 @@
 cat dog "chicken" 'dragon'
 """)
 
+    def test_verbosity_isolated(self):
+        """Global verbosity is isolated from commands run in scripts.
+        """
+        # see also 656694; we should get rid of global verbosity
+        self.run_script("""
+        $ bzr init --quiet a
+        """)
+        self.assertEquals(trace.is_quiet(), False)
+
 
 class TestCat(script.TestCaseWithTransportAndScript):
 

